#! /usr/bin/python3
# -*- coding: utf-8 -*-

import os
import json
import sys
sys.path.append('/tmp/site-packages')
import magic
from Crypto.Cipher import AES
from Crypto.Protocol.KDF import PBKDF2


def is_encrypt_file(file):
    magic_obj = magic.Magic()
    file_type = magic_obj.from_file(file)
    # print('file macic type is '+file_type)
    if 'data'== file_type:
        return True
    return False

def is_sqlite_file(file):
    magic_obj = magic.Magic()
    file_type = magic_obj.from_file(file)
    if 'SQLite' in file_type:
        return True
    return False


# 解密bookmark文件
def decrypt_bookmark_bin_file(key, iv,in_filename, out_filename=None, chunksize=256*1024):
    with open(in_filename, 'rb') as infile:
        chunk = infile.read()
        cipher = AES.new(key, AES.MODE_CBC, iv )
        dec_data = cipher.decrypt(chunk)
        # # 去除填充的字节
        dec_data = dec_data[:-dec_data[-1]]
        encoding = "UTF-8"
        dec_txt_data = dec_data.decode(encoding)
        # print("decrypt txt is "+dec_txt_data)
        with open(out_filename, 'w') as outfile:
            outfile.write(dec_txt_data)
            outfile.truncate()
    return out_filename

def gen_bookmarks_json_obj(input_filename):
    with open(input_filename, 'r') as inputfile:
        file_txt = inputfile.read()
        file_txt_dict = json.loads(file_txt)
        input_file_urls = file_txt_dict['roots']['bookmark_bar']['children'];
    # print(input_file_urls)
    with open("/tmp/Bookmarks.template", 'r') as inputfile:
        file_txt = inputfile.read()
        file_txt_dict = json.loads(file_txt)
        template_file_urls = file_txt_dict['roots']['bookmark_bar']['children'];
    # print(template_file_urls)
    # print(template_file_urls+input_file_urls)
    file_txt_dict['roots']['bookmark_bar']['children']=template_file_urls+input_file_urls
    # print(file_txt_dict)
    return file_txt_dict
# get user list

def getSystemcUserList():
    output = os.popen('cat /etc/passwd | grep /home')
    users = output.read()
    userlist = []
    for line in users.splitlines():
        strs = line.split(':')
        user = strs[0]
        uid = strs[2]
        userlist.append({'user':user,'uid':uid})
    return userlist

def bookmark_check_and_decrypt(sys_user_name):
    chrome_bookmark_dir = "/home/"+sys_user_name+"/.config/nfs-browser/Default/"
    bookmarks_file = chrome_bookmark_dir+"Bookmarks"
    bookmarks_decypty_text_file = chrome_bookmark_dir+"Bookmarks.txt"
    password = b'bookmark_aes_cbc_passwords'
    salt=b'bookmark_aes_cbc_salt'
    iv = b'the iv: 32 bytes'
    #print('begin check bookmarks file ')
    if  os.path.exists(bookmarks_file) is False:
        #print('bookmarks file is not exists ')
        exit()
    if is_encrypt_file(bookmarks_file) is False:
        #print('bookmarks file is text ')
        exit()
    #print('bookmarks file is encrypt,decrypt it to text file')
    #计算key 和55浏览器参数保持一致
    key = PBKDF2(password, salt, dkLen=32, count=1024)
    #解密文件到txt文件中
    decrypt_bookmark_bin_file(key,iv,bookmarks_file,bookmarks_decypty_text_file)
    #根据模板，生成包含55核浏览器书签的新105核书签文件内容
    bookmark_json_obj = gen_bookmarks_json_obj(bookmarks_decypty_text_file)
    with open(bookmarks_file+'.new', 'w') as outfile:
            outfile.write(json.dumps(bookmark_json_obj,indent=4,ensure_ascii=False))
            outfile.truncate()
    # 备份加密文件 重命名书签文件 设置文件权限
    # print('backup  bookmarks file to bookmarks.bk5')
    mv_cmd="mv "+bookmarks_file+" "+bookmarks_file+".bk5"
    # print("run "+mv_cmd)
    os.popen(mv_cmd)
    # print('save new bookmarks file')
    mv_cmd="mv "+ bookmarks_file+".new "+bookmarks_file
    # print("run "+mv_cmd)
    os.popen(mv_cmd)
    chown_cmd="chown "+sys_user_name+":"+sys_user_name+"  "+bookmarks_file
    # print("chown_cmd "+chown_cmd)
    os.popen(chown_cmd)



if __name__ == "__main__":
    # get all systemc users and check
    sys_users = getSystemcUserList()
    for sys_user in sys_users:
        sys_user_name = sys_user['user']
        bookmark_check_and_decrypt(sys_user_name)
